using System;

/* Weight of FibonacciNodes should be generic.
 * Generics themselves are crappy for this Heap, because Copmarison 
 * operators are assured about the interface IComparable, but + operator
 * does'nt have an interface. Because of that a generic class had to
 * encapsulate a value type and additionally support a user defined
 * interface like "IAddable" or sth.
 * 
 * Instead, the following statement should be sufficient for our needs. */
using TWeight = System.Decimal;

public class Matrix
{
	// Members
	public TWeight[][] paths;
	public int node;
	public int edge;


	// C'tor
	public Matrix(int size)
	{
		// Init and fill matrix
		this.paths = new TWeight[size][];

		for (int i=0; i<size; i++)
			this.paths[i] = new TWeight[size];

		for (int i=0; i<size; i++)
			for (int ii=0; ii<size; ii++)
				this.paths[i][ii] = -1;
	}
}