using System;
using System.Drawing;
using System.Windows.Forms;

public delegate void QueryForPathHandler(int start, int dest, int[] stopovers);

public class PathFinderControl : Panel
{
	private ComboBox startNode;
	private ComboBox endNode;
	private ListBox stopovers;
	private Label msg;
	public event QueryForPathHandler QueryForPath;

	public PathFinderControl()
	{
		// Start + end
		this.startNode = new ComboBox();
		this.startNode.Location = new Point(5, 5);
		this.startNode.Text = "Start";
		
		this.endNode = new ComboBox();
		this.endNode.Location = new Point(5, 35);
		this.endNode.Text = "Ziel";

		// Stopovers
		this.stopovers = new ListBox();
		this.stopovers.Location = new Point(5, 65);
		this.stopovers.Height = 100;
		this.stopovers.SelectionMode = SelectionMode.MultiSimple;

		// Fill controls with point-indices
		for (int i=0; i<16; i++)
		{
			this.startNode.Items.Add(i);
			this.endNode.Items.Add(i);
			this.stopovers.Items.Add(i);
		}

		// Button
		Button b = new Button();
		b.Location = new Point(5, 170);
		b.Text = "Get Path";

		// Label
		this.msg = new Label();
		this.msg.Location = new Point(5, 200);
		this.msg.Size = new Size(150, 60);
		// this.msg.BackColor = Color.Indigo;			// testing

		// Add controls
		this.Controls.Add(this.startNode);
		this.Controls.Add(this.endNode);
		this.Controls.Add(this.stopovers);
		this.Controls.Add(b);
		this.Controls.Add(this.msg);

		// Connect events
		b.Click += new EventHandler(this.SendQuery);
	}

	private void SendQuery(object sender, EventArgs e)
	{
		int[] so = new int[this.stopovers.SelectedIndices.Count];
		for (int i=0; i<so.Length; i++)
			so[i] = this.stopovers.SelectedIndices[i];

		if (this.QueryForPath != null)
			this.QueryForPath(this.startNode.SelectedIndex, this.endNode.SelectedIndex, so);
	}

	public void ReceivePath(int[] points)
	{
		string msg = "";
		msg += '{';
		if (points != null)
			for (int i=0; i<points.Length; i++)
			{
				msg += points[i].ToString();
				if (i < points.Length-1)
					msg += ", ";
			}
		msg += '}';

		this.msg.Text = msg;
	}
}
