using System;

public delegate void WeightChangedHandler(int weight);

public class TrackItem : ICloneable
{
	// Members
	public String name;		// debug
	public int id;
	private int weight;
	public TrackItem parent;
	
	// Events
	public event WeightChangedHandler WeightChanged;
	
	// Getter + Setter
	public int Weight
	{
		get {return this.weight;}
	    set
	    {
	        this.weight = value;
	        if (this.WeightChanged != null)
	            this.WeightChanged(this.weight);
	    }
	}
	
	public TrackItem(int id)
	{
		this.id = id;
		this.weight = -1;
	}

	public Object Clone()
	{
		return new TrackItem(this.id);
	}
}