using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

public class appForm : System.Windows.Forms.Form
{
	// Members
	private MatrixControl mc;
	private View v;
	private PathFinderControl pfc;

	public appForm()
	{
		this.Size = new Size(430, 650);
		this.Text = "Dijkstra";
		this.Name = "appForm";

		// Matrix
		this.mc = new MatrixControl(16);
		// this.mc.BackColor = Color.Green;		// testing
		this.mc.Dock = DockStyle.Top;		

		// View
		this.v = new View();
		// this.v.BackColor = Color.SlateGray;		// testing
		this.v.Top = this.mc.Height;
		this.Anchor = AnchorStyles.Top | AnchorStyles.Left;
		this.v.Dock = DockStyle.Fill;

		// Path finder
		this.pfc = new PathFinderControl();
		// this.pfc.BackColor = Color.Red	;		// testing
		this.pfc.Dock = DockStyle.Right;

		// Add controls
		this.Controls.Add(this.v);
		this.Controls.Add(this.pfc);
		this.Controls.Add(this.mc);

		// Connect events
		this.mc.OnApply += new OnApplyHandler(this.v.ShowPathNetwork);
		this.pfc.QueryForPath += new QueryForPathHandler(this.QueryForPath);
	}

	[STAThread]
	static void Main() 
	{
		Application.Run(new appForm());
	}

	private void QueryForPath(int start, int dest, int[] stopovers)
	{
		int[] path = Dijkstra.CreateRoute(this.mc.pathContainer, start, dest, stopovers);
		this.pfc.ReceivePath(path);
	}
}